<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 03/09/2010 *
 * ===================                          Last change: 03/09/2010 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-forced.php                                   *
 * -------------------------------------------------------------------- *
 * Short description : Clickable forced banner or text links            *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Klickbare Forced-Banner oder -Textlinks          *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009 - 2011 by Mailer Developer Team                   *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Version number
setThisExtensionVersion('0.0.0');

// Version history array (add more with , '0.0.1' and so on)
setExtensionVersionHistory(array('0.0.0'));

// This extension is in development (non-productive)
enableExtensionProductive(false);

switch (getExtensionMode()) {
	case 'register': // Do stuff when installation is running
		// All required tables for this extension:
		// - Ads
		addDropTableSql('forced_ads');
		addCreateTableSql('forced_ads', "
`forced_ads_id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`forced_ads_ad_url` VARCHAR(255) NULL DEFAULT NULL,
`forced_ads_click_url` VARCHAR(255) NOT NULL,
`forced_ads_width` SMALLINT(3) UNSIGNED NULL DEFAULT NULL,
`forced_ads_height` SMALLINT(3) UNSIGNED NULL DEFAULT NULL,
`forced_ads_alt_text` VARCHAR(255) NULL DEFAULT NULL,
`forced_ads_framebreaker` ENUM('Y','N') NOT NULL DEFAULT 'Y',
`forced_ads_type` VARCHAR(255) NOT NULL DEFAULT 'INVALID',
`forced_ads_views_counter` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`forced_ads_clicks_counter` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`forced_ads_reload_lock` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`forced_ads_min_stay` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`forced_ads_added` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
`forced_ads_last_locked` TIMESTAMP NULL DEFAULT NULL,
`forced_ads_lock_reason` TINYTEXT,
PRIMARY KEY (`forced_ads_id`)",
			'Forced Ads Data');

		// - Campaigns
		addDropTableSql('forced_campaigns');
		addCreateTableSql('forced_campaigns', "
`forced_campaign_id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`forced_campaign_created` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
`forced_campaign_status` ENUM('ACTIVE','PENDING','EXPIRED','LOCKED') NOT NULL DEFAULT 'PENDING',
`forced_campaign_lock_reason` VARCHAR(255) NULL DEFAULT NULL,
`forced_campaign_lock_timetstamp` TIMESTAMP NULL DEFAULT NULL,
`forced_campaign_expired` TIMESTAMP NULL DEFAULT NULL,
`forced_campaign_ordered_clicks` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`forced_campaign_costs_api` FLOAT(20,5) UNSIGNED NULL DEFAULT NULL,
`forced_campaign_price_api` FLOAT(20,5) UNSIGNED NULL DEFAULT NULL,
`forced_costs_id` BIGINT(20) UNSIGNED NULL DEFAULT NULL,
PRIMARY KEY (`forced_campaign_id`),
INDEX (`forced_costs_id`)",
			'Forced Campaign Data');

		// - Campaigns <-> Ads
		addDropTableSql('forced_campaigns_ads');
		addCreateTableSql('forced_campaigns_ads', "
`forced_campaign_ads_id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`forced_campaign_id` BIGINT(20) UNSIGNED NULL DEFAULT NULL,
`forced_ads_id` BIGINT(20) UNSIGNED NULL DEFAULT NULL,
PRIMARY KEY (`forced_campaign_ads_id`),
UNIQUE `ads_campaign`(`forced_campaign_id`,`forced_ads_id`)",
			'Forced Campaigns<->Ads');

		// - Campaigns <-> "User" (could be a member, sponsor, admin or "API")
		addDropTableSql('forced_campaigns_user');
		addCreateTableSql('forced_campaigns_user', "
`forced_id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`forced_campaign_id` BIGINT(20) UNSIGNED NULL DEFAULT NULL,
`forced_user_id` BIGINT(20) UNSIGNED NULL DEFAULT NULL,
`forced_user_type` ENUM('MEMBER','SPONSOR','ADMIN','API') NOT NULL DEFAULT 'ADMIN',
PRIMARY KEY (`forced_id`),
UNIQUE `forced_campaign_user` (`forced_campaign_id`,`forced_user_id`,`forced_user_type`),
INDEX (`forced_user_id`)",
			'Forced Campaigns<->User');

		// - Campaign costs
		addDropTableSql('forced_costs');
		addCreateTableSql('forced_costs', "
`forced_costs_id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`forced_costs_price_click` FLOAT(20,5) UNSIGNED NULL DEFAULT NULL,
`forced_costs_payment_click` FLOAT(20,5) UNSIGNED NULL DEFAULT NULL,
`forced_costs_visibility` ENUM('MEMBER','SPONSOR','ALL','NONE') NOT NULL DEFAULT 'NONE',
PRIMARY KEY (`forced_costs_id`)",
			'Forced Campaign Costs');

		// - Campaign Statistics
		addDropTableSql('forced_stats');
		addCreateTableSql('forced_stats', "
`forced_stats_id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`forced_stats_campaign_id` BIGINT(20) UNSIGNED NULL DEFAULT NULL,
`forced_stats_user_id` BIGINT(20) UNSIGNED NULL DEFAULT NULL,
`forced_stats_viewed` TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
`forced_stats_clicked` TIMESTAMP NULL DEFAULT NULL,
`forced_stats_real_ip` VARCHAR(15) NOT NULL DEFAULT '0.0.0.0',
`forced_stats_remote_addr` VARCHAR(15) NOT NULL DEFAULT '0.0.0.0',
`forced_stats_ua` VARCHAR(255) NULL DEFAULT NULL,
`forced_stats_is_proxy` ENUM('Y','N') NOT NULL DEFAULT 'N',
`forced_stats_session_id` VARCHAR(100) NULL DEFAULT NULL,
PRIMARY KEY (`forced_stats_id`),
INDEX (`forced_stats_campaign_id`),
INDEX (`forced_stats_user_id`)",
			'Forced Campaign Statistics');

		// Menu system
		// - Administrator
		addAdminMenuSql('forced', NULL, 'Forced-Ads', 'Verwalten Sie hier bequem alle laufenden Forced-Banner und -Textlinks und deren Kampgnen. Sie k&ouml;nnen hier auch neue Werbmittel (Ads) hinzuf&uuml;gen oder laufende Forced-Kampagnen bei z.B. Regelverst&ouml;ssen sperren oder l&ouml;schen. Auch das natr&auml;gliche Editieren von Ads und Kampagnen ist jederzeit m&ouml;glich. Kampagnen dienen der einfacheren Verwaltung und der Trennung von dem Werbemittel selbst dienen. Sie brauchen also z.B. einen Forced-Banner nur einmal einf&uuml;gen und k&ouml;nnen dann bei Bedarf weitere Kampagnen starten.', 5);
		addAdminMenuSql('forced', 'list_forced_ads', 'Werbemittel verwalten', 'Listet alle eingetragenen Werbmittel (Ads) auf und f&uuml;gt neue hinzu. Sie k&ouml;nnen hier diese nachtr&auml;glich editieren falls Sie mal eine falsche URL eingegeben haben oder den Text &auml;ndern wollen. L&ouml;schen Sie hier auch Forced-Banner, die nicht mehr g&uuml;ltig sind (z.B. abgelaufen sind). Sollten doch mit dem Werbmittel verkn&uuml;pfte Kampagnen vorhanden sein, erhalten Sie einen Warnhinweis. Neue Werbmittel k&ouml;nnen Sie hier ebenfalls hinzuf&uuml;gen. Denken Sie aber daran, dass ohne Kampagne dieses nicht angezeigt wird. Achten Sie hier auch die Reload-Sperre.', 2);
		addAdminMenuSql('forced', 'list_forced_campaigns', 'Kampagnen verwalten', 'Listet alle Kampagnen auf und zeigt deren Status an. Jederzeit k&ouml;nnen Sie Kampagnen stoppen, falls Sie dies w&uuml;nschen oder ein Regelverstoss vorliegt. Haben Sie ein Werbemittel hinzugef&uuml;gt, so f&uuml;gen Sie bitte unbedingt eine Kampagne hinzu, da es sonst nicht angezeigt wird.', 3);
		addAdminMenuSql('forced', 'list_forced_costs', 'Kosten verwalten', 'Legen Sie die Preise pro Klick zum Buchen Forced-Werbemittel fest und wie viele {OPEN_CONFIG}POINTS{CLOSE_CONFIG} Ihre Mitglieder erhalten sollen. Generell sollten Sie bei Mitgliederbuchungen h&ouml;here Kosten pro Klick als was Ihre Mitglieder pro Klick erhalten einstellen, da so die {OPEN_CONFIG}POINTS{CLOSE_CONFIG} abgebaut werden (Sie k&ouml;nnen an Accountaufladungen z.B. verdienen).', 4);
		addAdminMenuSql('forced', 'stats_forced', 'Statistiken', 'Zeigt Gesamtstatistiken und zu den einzelnen Kampagnen und Werbmitteln an. Die hier angezeigte Statistik kann jedoch nicht manuell gel&ouml;scht werden (bitte auch nicht selber tun) da sie auch gleichzeitigt als Reload-Sperre dient.', 5);

		// - Members
		addMemberMenuSql('earn', 'forced_banner', 'Forced-Banner', 2);
		addMemberMenuSql('earn', 'forced_textlink', 'Forced-Textlinks', 3);
		addMemberMenuSql('extras','book_forced_banner','Forced-Banner buchen', 3);
		addMemberMenuSql('extras','book_forced_textlink','Forced-Textlink buchen', 4);

		// Register filter for default forced ad types
		registerFilter('add_forced_ads_types', 'FORCED_AD_TYPE_DEFAULTS', false, true, isExtensionDryRun());
		break;

	case 'remove': // Do stuff when removing extension
		// SQL commands to run
		addDropTableSql('forced_ads');
		addDropTableSql('forced_campaigns');
		addDropTableSql('forced_campaigns_ads');
		addDropTableSql('forced_campaigns_user');
		addDropTableSql('forced_costs');
		addDropTableSql('forced_stats');

		// Menu systems
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_admin_menu` WHERE `action`='forced' LIMIT 5");
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE `what` IN ('forced_banner','forced_textlink') LIMIT 2");

		// Remove filter
		unregisterFilter(__FUNCTION__, __LINE__, 'add_forced_ads_types', 'FORCED_AD_TYPE_DEFAULTS', true, isExtensionDryRun());
		break;

	case 'activate': // Do stuff when admin activates this extension
		// SQL commands to run
		break;

	case 'deactivate': // Do stuff when admin deactivates this extension
		// SQL commands to run
		break;

	case 'update': // Update an extension
		switch (getCurrentExtensionVersion()) {
			case '0.0.1': // SQL queries for v0.0.1
				addExtensionSql('');

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes('');
				break;
		} // END - switch
		break;

	case 'modify': // When the extension got modified
		break;

	case 'test': // For testing purposes
		break;

	case 'init': // Do stuff when extension is initialized
		break;

	default: // Unknown extension mode
		logDebugMessage(__FILE__, __LINE__, sprintf("Unknown extension mode %s in extension %s detected.", getExtensionMode(), getCurrentExtensionName()));
		break;
} // END - switch

// [EOF]
?>
